/* K 6.9 ` 6.13, K 8.16 */

import java.awt.Color;

public class DrawGraph extends Turtle implements Drawable{
  /** gr ̔zŗ^ꂽ܂` */
  public void draw(int x, int y, int[] gr){
    up(); moveTo(gr[0] + x,gr[1] + y,0); down();
    for (int i=1;i< gr.length/2;i++) {
      moveTo(gr[i*2] + x,gr[i*2+1] + y,0);
    }
  }

  /** gr ŗ^ꂽ܂̔z` */
  public void draw(int x, int y, int[][] gr){
    for (int i=0;i< gr.length ;i++) {
      draw(x, y, gr[i]);
    }
  }

  /** Turtle NX̎Ă3C̋T̊G` */
  public void draw(){
    setColor(Color.red); draw(150,200, kameFig);
    setColor(Color.blue); draw(200,200, kameRFig);
    setColor(Color.green); draw(250,200, kameLFig);
  }

  /** Ă΂x, قȂG` */
  int turn = 0;
  int[][][] figs = {kameFig, kameRFig, kameLFig};

  public void draw(int x, int y){
    draw(x, y, figs[turn++ % 3]);
  }

  /** ܂̍Wϊ܂𐶐 */
  static int[] trans(int[] gr, int th, double s){
    int xx, yy;
    double ra = th * Math.PI / 180;
    int[] na = new int[gr.length];
    for (int i=0;i< gr.length/2;i++) {
      xx = gr[i * 2]; yy = gr[i * 2 + 1];
      na[i * 2] = (int)(s * (xx * Math.cos(ra) - yy * Math.sin(ra)));
      na[i * 2 + 1] = (int)(s * (xx * Math.sin(ra) + yy * Math.cos(ra)));
    }
    return na;
  }

  /** ܂̔zɑ΂ēƂs */
  static int[][] trans(int[][] gr, int th, double s){
    int[][] aaa = new int[gr.length][];
    for (int i=0;i< gr.length;i++) {
      aaa[i] =  trans(gr[i], th, s);
    }
    return aaa;
  } 

  /** e\bhɓĂ邩ׂ邽߂̃TvvO */
  public static void main(String[] args){
    TurtleFrame f = new TurtleFrame();
    DrawGraph m = new DrawGraph();  f.add(m);
    m.draw();
    m.draw(100,100);
    m.draw(150,100);
    m.draw(200,100);
    m.draw(250,100);
    m.setColor(Color.pink); 
    m.draw(50,300, trans(kameFig, 0, 0.3));
    m.draw(100,300, trans(kameFig, 30, 0.5));
    m.draw(150,300, trans(kameFig, 60, 0.7));
    m.draw(200,300, trans(kameFig, 90, 1.0));
    m.draw(300,300, trans(kameFig, 120, 2.0));
  }
}
