// K12.1
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.text.*;

class Himando extends JPanel implements ActionListener{
  Person hito;               //lIuWFNgpϐ
  JTextField hField,wField;   //̓tB[hpϐ
  JLabel hyoujun,hantei,himando;      //xpϐ
  NumberFormat fm, pfm;

  Himando(){
     fm = NumberFormat.getInstance();
     pfm = NumberFormat.getPercentInstance();
     setBackground(Color.white);
     setBorder(BorderFactory.createEmptyBorder(20, 20, 20, 20));  
                              //pl̎ɋ󔒂̋EĂ݂₷
     hField = new JTextField(10);  //̓tB[h𐶐
     wField = new JTextField(10);
     hyoujun = new JLabel();       //x𐶐
     hantei= new JLabel();
     himando= new JLabel();
     hField.addActionListener(this);  //̓tB[hɃXi[ݒ
     wField.addActionListener(this);
     setLayout(new GridLayout(5,2));  //CAEgݒ
     add(new JLabel("g(cm)"));      //plɕizu
     add(hField);                     
     add(new JLabel("̏d(Kg)"));
     add(wField);
     add(new JLabel("W̏d(Kg)"));
     add(hyoujun);
     add(new JLabel("얞x(%)"));
     add(himando);
     add(new JLabel("얞x"));
     add(hantei);

     hito = new Person();          //lIuWFNg
  }

  //̓tB[hreturnL[ꂽAs郁\bh
  public void actionPerformed(ActionEvent e){  
     float f;
     try{
        f = Float.valueOf(hField.getText()).floatValue();
     } catch (NumberFormatException error){ f = 0.0F; }
     hito.setHeight(f);    //gݒ

     try{
        f=Float.valueOf(wField.getText()).floatValue();
     } catch (NumberFormatException error){ f = 0.0F; }
     hito.setWeight(f);   //̏dݒ

     doCalc();        
   }

  void doCalc(){
     if(hito.getHeight() == 0) { hField.requestFocus(); }
     else if(hito.getWeight() == 0) { wField.requestFocus(); }
     else {
        hyoujun.setText(fm.format(hito.calcStdWeight()));  //W̏d\
        himando.setText(pfm.format(hito.calcHimando()));  //얞x\
        hantei.setText(hito.judgeHiman()); //얞x𔻒
     }
  }

  public static void main(String args[]) {
     JFrame f = new JFrame("Himando");
     Himando h = new Himando();        //얞xpl
     Container c = f.getContentPane(); 

     c.add(h, BorderLayout.CENTER);
     f.pack();                        
     f.setVisible(true);
  }
}

class Person{   //lNX
   private float weight;  //̏di[ϐ
   private float height;  //gi[ϐ

   float getWeight() { return weight; }  //̏dԂ\bh
   float getHeight() { return height; }  //gԂ\bh
   void setWeight(float w) { weight = w; }  //̏dݒ肷郁\bh
   void setHeight(float h) { height = h; }  //gݒ肷郁\bh

   float calcStdWeight(){ //W̏dvZ
      return (height-100)*0.9F;
   }

   float calcHimando(){  //얞xvZ
      float std = calcStdWeight();
      return (weight-std)/std;
   }

   String judgeHiman(){  //얞x𔻒
      float j = calcHimando();
      if (j < -0.2)  return "";
      else if (j >= -0.2 && j <-0.1)  return "";
      else if (j >= -0.1 && j <=0.1)  return "";
      else if (j > 0.1 && j <=0.2)  return "肬";
      else return "肷";
   }
}

