// Usage: %java Cal52 year month day
public class Cal52 {
  public static void main(String[] args){
    int[] mon = new int[]{0,31,28,31,30,31,30,31,31,30,31,30,31};
    if (args.length!=3) {
      System.out.println("Usage: java Cal52 year month day");
      System.exit(0);
    }
    int year = Integer.parseInt(args[0]);
    int month = Integer.parseInt(args[1]);
    int day = Integer.parseInt(args[2]);
    int totalDay = 0;
    for (int y = 1900; y<year; y++) {
      totalDay += 365;
      if (((y % 4 == 0)&&(y % 100 !=0))||(y % 400 == 0)) totalDay++;
    }

    if (((year % 4 == 0)&&(year % 100 !=0))||(year % 400 == 0)) mon[2]++;
    for (int i=0;i<month;i++) {
      totalDay += mon[i];
    }
    totalDay += day;
    System.out.println(totalDay);
  }
}
